#ifndef __ALGORITHMAN__DISCRETEGAME_H
    #define __ALGORITHMAN__DISCRETEGAME_H

    #include<set>
    #include<iostream>

    namespace AlgorithMan
    {

        class CombinatorialGamePosition
        {
            friend std::ostream& operator<<(std::ostream& os, const CombinatorialGamePosition&);
            protected:
                virtual void WriteToStream(std::ostream& os) const = 0;

            public:
                CombinatorialGamePosition();
                virtual ~CombinatorialGamePosition();

                virtual int PlayersTurn() = 0;
                virtual bool WinningPosition();
                virtual int PlayerWon() = 0; // by default, return 0 means noone won
                virtual std::set<CombinatorialGamePosition*> PossibleMoves() = 0;
        };

        std::ostream& operator<<(std::ostream& os, const CombinatorialGamePosition&);

        class CombinatorialGame
        {
            public:
                CombinatorialGame();
                virtual ~CombinatorialGame();

                virtual CombinatorialGamePosition* InitialPosition() = 0;
        };

        class CombinatorialGameAI
        {
            public:
                CombinatorialGameAI();
                virtual ~CombinatorialGameAI();

                int RatePosition(CombinatorialGamePosition* fromposition, int player);
                CombinatorialGamePosition* ChooseMove(CombinatorialGamePosition* fromposition);
        };

    }

#endif