
#include <iostream>
#include "combinatorialgame.h"


#include "tictactoe.h"
#define GAMECLASS TicTacToe


using namespace AlgorithMan;
using namespace std;


int main(int argc, char** argv)
{
    GAMECLASS game;
    CombinatorialGamePosition* currentposition = game.InitialPosition();
    CombinatorialGameAI ai;

    int players[] = {-1, 0, 1 }; // 1 = human, 0 = AI (0 is not a player => index 0 = -1)
    while(true)
    {
        int playersturn = currentposition->PlayersTurn();
        CombinatorialGamePosition* nextposition = NULL;
        cout << *currentposition << "\n";
        if(currentposition->WinningPosition())
            break;


        if(players[playersturn] == 1)
        {
            set<CombinatorialGamePosition*> moves = currentposition->PossibleMoves();
            if(moves.size() > 0)
            {
                int i = 1;
                cout << "Player "<<playersturn<<", choose:\n";
                for(set<CombinatorialGamePosition*>::iterator m = moves.begin(); m != moves.end(); m++)
                    cout << i++ << ":\n" << (**m);
                cin >> i;

                nextposition = currentposition; // just cycle in case of illegal input
                for(set<CombinatorialGamePosition*>::iterator m = moves.begin(); m != moves.end(); m++)
                    if(--i == 0)
                    {
                        nextposition = *m;
                        moves.erase(nextposition);
                        break;
                    }
                for(set<CombinatorialGamePosition*>::iterator m = moves.begin(); m != moves.end(); m++)
                    delete *m;
            }
        }
        else
            nextposition = ai.ChooseMove(currentposition);


        if(nextposition == NULL)
            break;
        if(nextposition != currentposition)
        {
            CombinatorialGamePosition* temp = currentposition;
            currentposition = nextposition;
            delete temp;
        }
    }


    if(currentposition->WinningPosition())
        cout << "Player " << currentposition->PlayerWon() << " Won!\n";
    else
        cout << "Draw!\n";


    delete currentposition;
    return 0;
}
