
#include "tictactoe.h"
using namespace AlgorithMan;
using namespace std;


TicTacToePosition::TicTacToePosition()
    : CombinatorialGamePosition()
{
    for(int i = 0; i < 3; i++)
        for(int j = 0; j < 3; j++)
            field[i][j] = 0;
    fieldspicked = 0;
}

TicTacToePosition::TicTacToePosition(const TicTacToePosition& copy)
{
    for(int i = 0; i < 3; i++)
        for(int j = 0; j < 3; j++)
            field[i][j] = copy.field[i][j];
    fieldspicked = copy.fieldspicked;
}

TicTacToePosition::~TicTacToePosition()
{
}

int TicTacToePosition::PlayerWon()
{
    for(int i = 0; i < 3; ++i)
    {
        // vertical
        if((field[i][0] != 0) && (field[i][0] == field[i][1]) && (field[i][1] == field[i][2]))
            return field[i][0];

        // horizontal
        if((field[0][i] != 0) && (field[0][i] == field[1][i]) && (field[1][i] == field[2][i]))
            return field[0][i];
    }

    // diagonal
    if((field[0][0] != 0) && (field[0][0] == field[1][1]) && (field[1][1] == field[2][2]))
        return field[0][0];
    if((field[0][2] != 0) && (field[0][2] == field[1][1]) && (field[1][1] == field[2][0]))
        return field[0][2];

    return 0;
}

int TicTacToePosition::PlayersTurn()
{
    return (fieldspicked % 2) + 1;
}

std::set<CombinatorialGamePosition*> TicTacToePosition::PossibleMoves()
{
    std::set<CombinatorialGamePosition*> result;
    int player = PlayersTurn();

    for(int i = 0; i < 3; i++)
        for(int j = 0; j < 3; j++)
            if(field[i][j] == 0)
            {
                TicTacToePosition* p = new TicTacToePosition(*this);
                p->field[i][j] = player;
                p->fieldspicked++;
                result.insert(p);
            }

    return result;
}

void TicTacToePosition::WriteToStream(std::ostream& os) const
{
    for(int i = 0; i < 3; i++)
    {
        for(int j = 0; j < 3; j++)
            os << ((field[i][j] == 0) ? "   " : ((field[i][j] == 1) ? " X " : " O "))
                 << ((j==2) ? "\n" : "|");
        os << ((i==2) ? "" : "---+---+---\n");
    }
}





TicTacToe::TicTacToe()
    : CombinatorialGame()
{
}

TicTacToe::~TicTacToe()
{
}

CombinatorialGamePosition* TicTacToe::InitialPosition()
{
    return new TicTacToePosition();
}

